/*======================================================================
CLASS Ini2(cIniFile)

Author: Daniel Howard sproket@total.net

Version History: 
   1.0   June 1, 1998 
         Initial Version 
         New method GetSections.
         Returns an array of all sections in the INI.

   1.1   November 2, 1998
         Overrode GetSection.
         Automatically calles SectionArrayParse2Arrays

   1.2   November 23, 1998
         Changed GetSections to return a copy of the SectionArray
         instead of a pointer.

Written for: Visual dBASE 7.01

Inherits: Ini


Methods:

GetSections : This method retrieves all sections from the 
              ini file and stores them in the SectionArray 
              property.

SetIniFile :  This method overrides the one in the parent 
              class. This version allows you to use other
              extentions for your file. This also only uses
              the current directory if no path is specified.
              This method will not be called unless you make
              a slight change in the parent class.
              In the constructor 
              change:---> class::SetIniFile(cIniFile)
              to:-------> this.SetIniFile(cIniFile)
              This method is not really necessary as you can
              simply assign the iniFile property manually.

Notes:   Edit the original Ini & change the CLASS:: call to "THIS"

*----------------------------------------------------------------------
This software is donated to the public domain. You may modify 
this code in anyway you wish however the author reserves the 
right to whatever official version is published. If you have 
further ideas/bug reports/additions then contact the author and 
your name will be added to the contributors if your idea is 
implemented.

The author accepts no responsibility for the use or consequences 
of the use of this software.
*/

Class Ini2(cIniFile) Of Ini(cIniFile) from "ini.cc"

   Function GetSections
   local f,cBuffer

      f = New File()
      f.Open(this.IniFile)
      this.SectionArray := New Array()

      do while not f.eof()
         cBuffer = rtrim(ltrim(f.ReadLn()))
         if left(cBuffer,1) == "["
            this.SectionArray.Add(substr(cBuffer,2,len(cBuffer)-2))            
         endif                              
      enddo
      f.Close()

      // Return a COPY in case you call another method which
      // affects the SectionArray. This is to prevent a possible
      // problem if you call GetSection() in a loop since it also
      // writes to SectionArray.
      local a
      a = New array(this.SectionArray.Size)
      if a.Size > 0
         acopy(this.SectionArray,a)
      endif
   return ( a )

   FUNCTION SetIniFile
      parameter cIniFile
      if type("cIniFile") <> "C" && no file name specified
         // use program name
         this.IniFile = left(program(),8)+".INI"
      else
         this.IniFile = ltrim(trim(cIniFile))
      endif

      if .not. ("\" $ this.IniFile)  && if no path specified
     		this.IniFile = set("DIRECTORY") + "\" +this.IniFile
      endif
   return

   Function GetSection(c)
      local a
      a = Super::GetSection(c)
      this.SectionArrayParse2Arrays()
   return ( a )

endclass
