/*
     MENUAPI.PRG
     Jim Sare

     March 10, 1999

     Using the Windows API SendMessage() function,
     you can add some menu options to an MDI WINDOW
     menu ...

     This contains:

     GetParent()
     SendMessage()
     RefreshWinMenu()

     Usage:
        SET PROCEDURE TO :dUFLP:MENUAPI ADDITIVE

         // Create menu items in your Window menu with the 
         // following onClick events:

       "Next"
         function onClick 
         SendMessage( getParent( form.hWnd), HToI( "0224"),0, 0 )

        "Cascade"    
         function onClick
         SendMessage( getParent( form.hWnd), HToI( "0227"),0, 0 ) 

        "Tile Horizontally"
         function onClick
         SendMessage( getParent( form.hWnd), HToI( "0226"),1, 0 ) 

         "Tile Vertically"
         function onClick
         SendMessage( getParent( form.hWnd), HToI( "0226"),0, 0 ) 

        "Arrange Icons"
         function onClick
         SendMessage( getParent( form.hWnd), HToI( "0228"),0, 0 ) 

        RefreshWinMenu()
          Updates the Windows menu ...
*/

msgbox( "This program is not meant to be executed, "+;
        "but contains useful API calls.","Don't run this!", 16 )
return

if type( "GetParent" ) # "FP"
   extern CHANDLE GetParent( CHANDLE ) User32
endif

if type( "SendMessage" ) # "FP"
   extern CLONG SendMessage( CHANDLE, CINT, CWORD, CLONG ) User32 ;
          from "SendMessageA"
endif

Procedure RefreshWinMenu
/*
    Created by Jim Sare, posted by Romain Strieff in the
    dBASE2000 newsgroups, May 2, 1999

    This forces a refresh of the Windows menu in
    an application.
*/
   If Type("GetParent") # "FP"
      extern CHANDLE GetParent(CHANDLE) User32
   EndIf
   If Type("SendMessage") # "FP"
      extern CLONG SendMessage(CHANDLE, CUINT, CLONG, CLONG) User32;
             From "SendMessageA"
   EndIf
   #define WM_INITMENU         0x0116
   #define WM_MDIREFRESHMENU   0x0234
   SendMessage(GetParent(FORM.hWND), WM_MDIREFRESHMENU, 0, 0)

// eop: RefreshWinMenu
